/// <reference types="node" />
import path from "path";
interface CreateLibraryOptions {
    /** @default "lib" */
    outDir: string;
    /** @default false */
    iconIndex: boolean | string;
    /**
     * Callback to add a list of classes to the SVG element
     * provided the original filename and module name
     * @example
     * filename: "alarm-fill"
     * moduleName: "AlarmFill"
     */
    appendClassNames: (filename: string, moduleName: string) => undefined | string[];
    /**
     * Override the default module name
     */
    toModuleName: (params: {
        path: path.ParsedPath;
        moduleName: string;
    }) => string;
}
declare type ModuleNames = string[];
export declare const createIndexFile: (moduleNames: ModuleNames) => string;
export declare const createIconIndex: (moduleNames: ModuleNames) => string;
export declare function createLibrary(glob: string, options: Partial<CreateLibraryOptions>): Promise<void>;
export {};
