"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __values = (this && this.__values) || function(o) {
    var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
    if (m) return m.call(o);
    if (o && typeof o.length === "number") return {
        next: function () {
            if (o && i >= o.length) o = void 0;
            return { value: o && o[i++], done: !o };
        }
    };
    throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
};
var __read = (this && this.__read) || function (o, n) {
    var m = typeof Symbol === "function" && o[Symbol.iterator];
    if (!m) return o;
    var i = m.call(o), r, ar = [], e;
    try {
        while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
    }
    catch (error) { e = { error: error }; }
    finally {
        try {
            if (r && !r.done && (m = i["return"])) m.call(i);
        }
        finally { if (e) throw e.error; }
    }
    return ar;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
exports.createLibrary = exports.createIconIndex = exports.createIndexFile = void 0;
var tiny_glob_1 = __importDefault(require("tiny-glob"));
var promises_1 = __importDefault(require("fs/promises"));
var fs_1 = require("fs");
var path_1 = __importDefault(require("path"));
var template_1 = require("./template");
var to_module_name_1 = require("./to-module-name");
var createIndexFile = function (moduleNames) {
    return moduleNames
        .map(function (moduleName) {
        return "export { default as ".concat(moduleName, " } from \"./").concat(moduleName, ".svelte\";\n");
    })
        .join("");
};
exports.createIndexFile = createIndexFile;
var createIconIndex = function (moduleNames) { return "# Icon Index\n\n> ".concat(moduleNames.length, " total icons\n\n## Icons\n\n").concat(moduleNames.map(function (moduleName) { return "- ".concat(moduleName, "\n"); }).join("")); };
exports.createIconIndex = createIconIndex;
function createLibrary(glob, options) {
    var _a, _b, _c;
    return __awaiter(this, void 0, void 0, function () {
        var outDir, iconIndex, libPath, libDir, error_1, dir, files, moduleNames, files_1, files_1_1, filename, source, parsedPath, moduleName, classes, e_1_1, uniqueModuleNames, index, error_2;
        var e_1, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    outDir = (_a = options === null || options === void 0 ? void 0 : options.outDir) !== null && _a !== void 0 ? _a : "lib";
                    iconIndex = false;
                    if (typeof (options === null || options === void 0 ? void 0 : options.iconIndex) === "string") {
                        iconIndex = options.iconIndex;
                    }
                    else if ((options === null || options === void 0 ? void 0 : options.iconIndex) === true) {
                        iconIndex = "ICON_INDEX.md";
                    }
                    libPath = glob;
                    if (!/^node_modules/.test(libPath)) {
                        libPath = path_1["default"].join("node_modules", glob);
                    }
                    if (!/\*.svg$/.test(libPath)) {
                        libPath = path_1["default"].join(libPath, "*.svg");
                    }
                    libDir = path_1["default"].parse(libPath).dir;
                    _e.label = 1;
                case 1:
                    _e.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, promises_1["default"].stat(libDir)];
                case 2:
                    _e.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _e.sent();
                    console.error("[createLibrary] path does not exist: ".concat(libDir));
                    process.exit(1);
                    return [3 /*break*/, 4];
                case 4:
                    _e.trys.push([4, 17, , 18]);
                    dir = path_1["default"].join(process.cwd(), outDir);
                    if (!(0, fs_1.existsSync)(dir)) return [3 /*break*/, 6];
                    return [4 /*yield*/, promises_1["default"].rm(dir, { recursive: true })];
                case 5:
                    _e.sent();
                    _e.label = 6;
                case 6: return [4 /*yield*/, promises_1["default"].mkdir(dir)];
                case 7:
                    _e.sent();
                    return [4 /*yield*/, (0, tiny_glob_1["default"])(libPath.replace(/\*.svg$/, "**/*.svg"))];
                case 8:
                    files = _e.sent();
                    moduleNames = [];
                    _e.label = 9;
                case 9:
                    _e.trys.push([9, 14, 15, 16]);
                    files_1 = __values(files), files_1_1 = files_1.next();
                    _e.label = 10;
                case 10:
                    if (!!files_1_1.done) return [3 /*break*/, 13];
                    filename = files_1_1.value;
                    return [4 /*yield*/, promises_1["default"].readFile(filename, "utf-8")];
                case 11:
                    source = _e.sent();
                    parsedPath = path_1["default"].parse(filename);
                    moduleName = (0, to_module_name_1.toModuleName)(parsedPath.name);
                    if (options === null || options === void 0 ? void 0 : options.toModuleName) {
                        moduleName = options.toModuleName({ path: parsedPath, moduleName: moduleName });
                    }
                    classes = (_c = (_b = options === null || options === void 0 ? void 0 : options.appendClassNames) === null || _b === void 0 ? void 0 : _b.call(null, parsedPath.name, moduleName)) !== null && _c !== void 0 ? _c : [];
                    promises_1["default"].writeFile(path_1["default"].join(dir, "".concat(moduleName, ".svelte")), (0, template_1.templateSvelte)(source, filename, { classes: classes }));
                    promises_1["default"].writeFile(path_1["default"].join(dir, "".concat(moduleName, ".svelte.d.ts")), (0, template_1.templateTs)(moduleName));
                    moduleNames.push(moduleName);
                    _e.label = 12;
                case 12:
                    files_1_1 = files_1.next();
                    return [3 /*break*/, 10];
                case 13: return [3 /*break*/, 16];
                case 14:
                    e_1_1 = _e.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 16];
                case 15:
                    try {
                        if (files_1_1 && !files_1_1.done && (_d = files_1["return"])) _d.call(files_1);
                    }
                    finally { if (e_1) throw e_1.error; }
                    return [7 /*endfinally*/];
                case 16:
                    uniqueModuleNames = __spreadArray([], __read(new Set(moduleNames)), false);
                    index = (0, exports.createIndexFile)(uniqueModuleNames);
                    promises_1["default"].writeFile(path_1["default"].join(dir, "index.js"), index);
                    promises_1["default"].writeFile(path_1["default"].join(dir, "index.d.ts"), index);
                    console.log("\u26A1 Converted ".concat(uniqueModuleNames.length, " icons from \"").concat(glob, "\" to Svelte components in \"").concat(outDir, "\""));
                    if (iconIndex) {
                        promises_1["default"].writeFile(path_1["default"].join(process.cwd(), iconIndex), (0, exports.createIconIndex)(uniqueModuleNames));
                        console.log("\u270F\uFE0F Wrote icon index to \"".concat(iconIndex, "\""));
                    }
                    return [3 /*break*/, 18];
                case 17:
                    error_2 = _e.sent();
                    console.error(error_2);
                    return [3 /*break*/, 18];
                case 18: return [2 /*return*/];
            }
        });
    });
}
exports.createLibrary = createLibrary;
