"use strict";
exports.__esModule = true;
exports.templateTs = exports.templateSvelte = void 0;
var compiler_1 = require("svelte/compiler");
var templateSvelte = function (source, filename, _a) {
    var classes = _a.classes;
    var ast = (0, compiler_1.parse)(source, { filename: filename });
    var svg_attributes = "";
    var svg_children = "";
    classes.forEach(function (name) { return (svg_attributes += " class:".concat(name, "={true}")); });
    (0, compiler_1.walk)(ast.html, {
        enter: function (node) {
            if (node.type === "Element" && node.name === "svg") {
                node.children.forEach(function (child) {
                    svg_children += source.slice(child.start, child.end);
                });
                node.attributes.forEach(function (_a) {
                    var name = _a.name, value = _a.value;
                    if (name === "class") {
                        value[0].raw.split(" ").forEach(function (name) {
                            svg_attributes += " class:".concat(name, "={true}");
                        });
                    }
                    else {
                        svg_attributes += " ".concat(name, "=\"").concat(value[0].raw, "\"");
                    }
                });
            }
        }
    });
    return "<svg".concat(svg_attributes, " {...$$restProps}><slot />").concat(svg_children.trim(), "</svg>");
};
exports.templateSvelte = templateSvelte;
var templateTs = function (moduleName) { return "/// <reference types=\"svelte\" />\nimport { SvelteComponentTyped } from \"svelte\";\n\nexport interface ".concat(moduleName, "Props\n  extends svelte.JSX.SVGAttributes<SVGSVGElement> {}\n\nexport default class ").concat(moduleName, " extends SvelteComponentTyped<\n  ").concat(moduleName, "Props,\n  {},\n  { default: {} }\n> {}\n"); };
exports.templateTs = templateTs;
